/* Test program for 15-410 project 3 Fall 2003
 * Dave Eckhardt
 *
 * "cho" = "continuous hours of operation"
 *
 * keep a pile of tests of specifiled names active
 */

#include <syscall.h>
#include <stdio.h>
#include "410_tests.h"

static char test_name[] = "cho:";

struct prog {
	char *name;
	int pid;
	int count;
} progs[] = {
	{"sleep_test1", -1, 13},
	{"wait_getpid", -1, 100},
	{"wild_test1", -1, 100},
	{"exec_basic", -1, 100},
	{"print_basic", -1, 100}
};

int main()
{
	int active_progs = sizeof (progs) / sizeof (progs[0]);
	int active_processes = 0;
	struct prog *p, *fence;

	lprintf("%s%s%s",TEST_PFX,test_name,TEST_START_CMPLT);

	fence = progs + active_progs;

	while ((active_progs > 0) || (active_processes > 0)) {

		/* launch some processes */
		for (p = progs; p < fence; ++p) {
			if ((p->count > 0) && (p->pid == -1)) {
				int pid = fork();

				if (pid == -1) {
					sleep(1);
				} else if (pid == 0) {
					char *args[2];

	 			        lprintf("%s%s After fork(): I am a child!", TEST_PFX, test_name);

					args[0] = p->name;
					args[1] = 0;
					exec(p->name, args);
				} else {
					p->pid = pid;
					++active_processes;
				}
			}
		}

		/* reap a child */
		if (active_processes > 0) {
			int pid, status;
			pid = wait(&status);
			lprintf("%s%s After wait(): pid = %d", TEST_PFX, test_name, pid); /* progress */
			for (p = progs; p < fence; ++p) {
				if (p->pid == pid) {
					p->pid = -1;
					--p->count;
					if (p->count <= 0)
						--active_progs;
					--active_processes;
				}
			}
		}
	}

	lprintf("%s%s%s",TEST_PFX,test_name,TEST_END_SUCCESS);
	exit(0);
}
