# This is the include file for the make file.
# You should only have to edit this file to get things to build.
#

#
# Specifies the method for acquiring and project updates. This should be
# "afs" for any andrew machine, "web" for non-andrew machines and
# "offline" for machines with no network access.
#
# "offline" is strongly not recommended as you may miss important project
# updates.
#
UPDATE_METHOD = afs

#
# A list of the kernel object files you want included from 410kernel
#
410KERNEL_OBJS = load_helper.o#

#
# A list of the kernel object files you want included from kernel
#
KERNEL_OBJS = console.o kernel.o loader.o malloc_wrappers.o id.o syscall.o vm.o timer.o task.o thread.o frame.o scheduler.o list.o stubs.o interrupt.o io.o

#
# A list of the test programs you want compiled in from the 410user/progs
# directory
#
410PROGS = print_basic halt_test knife merchant peon cho wild_test1 stack_test1 sleep_test1 wait_getpid exec_basic exec_basic_helper fork_wait_bomb fork_exit_bomb init shell

#
# A list of the test programs you want compiled in from the user/progs
# directory
#
STUDENTPROGS =

# list the object files for your thread library
THREAD_OBJS = thread-malloc.o resource.o thread.o mutex.o cond.o sem.o rwlock.o

# list the object files for your syscall wrappers
SYSCALL_OBJS = thread_fork.o halt.o get_ticks.o misbehave.o set_term_color.o getchar.o sleep.o remove_pages.o gettid.o make_runnable.o deschedule.o wait.o exit.o yield.o exec.o get_cursor_pos.o ls.o new_pages.o print.o readline.o set_cursor_pos.o fork.o

