#!/usr/local/bin/perl -w

#
# This is a perl script for downloading the files not included in the handout
#
# Michael Ashley-Rollman(mpa)
#

use strict;

my $config = "config.mk";
my $afs_path = "/afs/cs.cmu.edu/academic/class/15410-s04/Web/update/proj3";
my $web_url  = "http://www-2.cs.cmu.edu/~410/update/proj3";

open (FILE, $config) || die "unable to read $config: $!";

my $config_line;
my $update_method = "";

# get update method from config file
foreach $config_line (<FILE>) {
    $update_method = $1 if ($config_line =~ "^UPDATE_METHOD.*=(.*)");
}
chomp $update_method;

if ($update_method =~ "afs") {
  `cp $afs_path/update.pl .`;
}
elsif ($update_method =~ "web") {
  `wget $web_url/update.pl .`;
  `chmod +x update.pl`;
}
else {
  die "UPDATE_METHOD must be set to either \"afs\" or \"web\" in config.mk\n";
}

`./update.pl $update_method`;

