/** @file syscall.h
 *  @brief The interface for handling system syscalls
 *  
 *  @author Lee Salzman (lsalzman)
 *  @bug No known bugs.
 */

#ifndef __KERN_SYSCALL_H__
#define __KERN_SYSCALL_H__



typedef struct
{
  /*The name of the task */
  char * execname;
  /*The arguments to the task */
  char ** execvec;
} ExecArgs;

typedef struct
{
  /*point to the memory region */
  void * addr;
  /*the length of the memory region */
  int len;
} NewPagesArgs;

typedef struct
{
  /* length of the buffer */
  int size;
  /*pointer to the buffer */
  char * buf;
} LSArgs;

/** @brief Initialize the system syscalls
 *
 *  Installs the system syscalls
 *
 *  @param none
 *
 *  @return returns 0 on success and -1 on failure                    
 */
extern int syscall_initialize (void);

#endif /* __KERN_SYSCALL_H__ */

