/** @file list.c
 *  @brief Provides the implementantion of list utility functions
 *
 *  @author Lee Salzman (lsalzman)
 *  @author Hassaan Moin Khan (hkhan)
 *  @bug No known bugs.
 */

#include <list.h>

void
list_clear (List * list)
{
    /* point the sentinel at itself */
    list -> sentinel.next = & list -> sentinel;
    list -> sentinel.previous = & list -> sentinel;
}

ListIterator
list_insert (ListIterator position, void * value)
{   
    ListNode * node = (ListNode *) value;

    /* point the position's previous field at the node, and the node's next field at the position */
    node -> next = position;
    node -> previous = position -> previous;
    position -> previous = node;
    node -> previous -> next = node;

    return node;
}

void *
list_remove (ListIterator position)
{   
    /* relink the previous element to the element after the position */
    position -> previous -> next = position -> next;
    position -> next -> previous = position -> previous;

    return position;
}

unsigned int
list_size (List * list)
{
    ListIterator position;
    unsigned int size = 0;

    /* iterate through the list, counting the elements */
    for (position = list_begin (list); position != list_end (list); position = list_next (position))
    {
         ++ size;
    }

    return size;
}
   
