/** @file mutex.h
 *  @brief This file defines the interface for mutexes.
 *
 *  @author Lee Salzman (lsalzman)
 *  @author Hassaan Khan (hkhan)
 */

#ifndef MUTEX_TYPE_H
#define MUTEX_TYPE_H

#include <threadlib.h>

/** @brief Mutex implementation structure.
 *
 *  Implements mutexes as a thread synchronization
 *  resource with an associated locking depth.
 */  
typedef struct mutex {
  /* the thread resource for synchronization */
  thread_resource_t resource;
  /* the locking depth is 0 if unlocked, or > 0 if locked */
  int lockDepth;
} mutex_t;

#endif /* MUTEX_TYPE_H */
