/** @file cond.h
 *  @brief This file defines the interface for condition variables.
 *
 *  @author Lee Salzman (lsalzman)
 *  @author Hassaan Khan (hkhan)
 */

#ifndef COND_TYPE_H
#define COND_TYPE_H

#include <threadlib.h>
#include <mutex.h>

/** @brief Condition variable implementation structure.
 *
 *  Implements condition variables as a thread resource
 *  where waiting threads sleep on the resource until they
 *  are signaled to wake them up
 */
typedef struct cond {  
  /* the thread synchronization resource */
  thread_resource_t resource;
} cond_t;

#endif /* COND_TYPE_H */
