/** @file rwlock.h
 *  @brief This file defines the interface to readers/writers locks
 *
 *  @author Hassaan Khan (hkhan)
 */

#ifndef RWLOCK_TYPE_H
#define RWLOCK_TYPE_H

#include <cond.h>
#include <mutex.h>

#define RWLOCK_READ  0
#define RWLOCK_WRITE 1

/** @brief the reader/writer structure 
 */
typedef struct rwlock {
  int writing;
  int rdcnt;
  int wcnt;
  cond_t conw;
  cond_t conr;
  mutex_t rwmut;
} rwlock_t;

#endif /* RW_TYPE_H */
