/** @file thread.h
 *  @brief This file defines the interface to the thread library
 *
 *  This file should contain ONLY the interface to the thread library
 *  It should NOT contain any of the thread library internals.
 *  Therefore, you may NOT modify this file.
 */



#ifndef THREAD_H
#define THREAD_H

#include <cond.h>
#include <mutex.h>

/* thread library functions */
int thr_init( unsigned int size );
int thr_create( void *(*func)(void *), void *args );
int thr_join( int tid, int *departed, void **status );
void thr_exit( void *status );
int thr_getid();

#endif /* THREAD_H */
